/* Copyright (c) 2003, Rob Bloom
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the <organization> nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY ROB BLOOM ''AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL ROB BLOOM BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// Translatemorse.c
// v1.0

#include <string.h>
#include <stdlib.h>

#include "morse.h"
#include "translatemorse.h" // Contains the morse<->text tables.

char * translate_morse(char *morse) {
  // My original plan was to create a bunch of complex string sorting
  // functions... Then I realized I can just use strtok and strcmp.
  char *willy;        // the name willy will make sense soon.
  static char *out;   // bonus points if you get it early.

  int first = 1;

  int eger; // For iterations.

  willy = malloc(128);// Overkill... Oh well. 128 bytes of RAM is nothing these
  if (!out)
  out = malloc(8192); // days... Even on my 486, wasting 100 bytes of RAM 
  out[0] = 0;         // is no big deal at all. 8192, that's definately
                      // overkill, too.  Oh well, better to be too big than
                      // too small.  You know, that's close to being 1k total
                      // for just here.  If this were supposed to be some BG
                      // program, it'd probably be very bad. But this is the
                      // kind of program that runs in the foreground, so a
                      // user's attention is constantly on it.  When that's
                      // so, I feel it's okay to waste their RAM as I see
                      // fit. =P
  while ( (willy = strtok((first ? morse : 0), " ")) ) {
    first = 0;
    out[strlen(out)+1] = 0;
    out[strlen(out)] = ' '; // Just in case it's nonsense.
    for (eger = 0; morsechars[eger] != 0; eger++) {
      if ( !strcmp(willy, morsestrings[eger]) ) {
	out[strlen(out)-1] = morsechars[eger];
	break;
      } // if
    } // for
  } // while
  free(willy); // Haha.
  return out;
}
  // You know, I think I've gotten somewhat better at commenting my code than
  // I was a while ago.  The problem now, however, is that my comments
  // sometimes aren't relevant.  This one, for example.  You know, I blame
  // Nethack for my random comment diversions.  I was reading it's source code
  // one day and it had this lil mini story about some guy confused by nuns
  // who constantly wear bathrobes, even when bathing, because "God is
  // watching", etc.  This confused him, because of the idea of that God's
  // vision being able to pierce the ceiling and all all the floors above and
  // everything but not a bathrobe.

  // ...It was a lot funnier when he told it.  Go read Nethack's source code.
  // I think it was somewhere in the section on praying to your god... Oh well.
  // just grep for "nun" in *.c =P
