/* Copyright (c) 2003, Rob Bloom
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the <organization> nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY ROB BLOOM ''AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL ROB BLOOM BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// Translatemorse.h
// v1.0

// These morse<->text tables were based off of the ones provided by Ian
// Kluft KO6YQ. http://www.kluft.com/~ikluft/ham/morse-intro.html

// Also, if you read his introduction, he mentions that learning morse as
// a combo of -s and .s, as opposed to how they sound, is a bad idea.
// Please ignore how I supply my program with the morse code translations.

// The original plan was to use a struct.  However, this'll be easier to
// initialize in a header:

// Here's our morse codes
#ifndef MORSE
#define MORSE
char *morsestrings[] = {
  // Letters
  ".-", "-...", "-.-.", "-..", ".", "..-.", "--.", "....", "..", ".---",
  "-.-", ".-..", "--", "-.", "---", ".--.", "--.-", ".-.", "...", "-",
  "..-", "...-", ".--", "-..-", "-.--", "--..",
  // Numbers
  ".----", "..---", "...--", "....-", ".....", "-....", "--...", "---..",
  "----.", "-----",
  // Punctuation
  "-..-.", "--..--", ".-.-.-", "..--..",
  // Nothing (these are technically not morse code)
  ",", 0
}; // Ugh, typed that all out manually.  Probably be a lot easier if I know
   // morse code. =P  Actually, as of now, I probably know somewhere around
   // half of this table.  Just need to practice/keep learning, etc.

// here's what they look like as text.
char *morsechars =
"abcdefghijklmnopqrstuvwxyz1234567890/,.?";

#endif // MORSE

// Yay! I'm done.
